Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5075)
@@ -134,104 +1503,34 @@
       ENDDO
 
-      IF( il_varid/=0 )THEN
-         IF( ASSOCIATED(td_file%t_var(il_varid)%d_value) )THEN
-            CALL logger_debug("GRID GET PIVOT: ASSOCIATED")
-            tl_var=td_file%t_var(il_varid)
-         ELSE
-            ! read variable
-            il_dim(:)=td_file%t_var(il_varid)%t_dim(:)%i_len
-
-            CALL logger_debug("GRID GET PIVOT: read variable")
-            tl_var=iom_read_var(td_file, td_file%t_var(il_varid)%c_name,     &
-            &                   id_start=(/1,il_dim(2)-3,1,1/), &
-            &                   id_count=(/3,4,1,1/) )
-         ENDIF
-
-         CALL logger_debug("GRID GET PIVOT: use variable "//TRIM(tl_var%c_name))
-
-         IF( ASSOCIATED(tl_var%d_value) )THEN
-
-            CALL logger_debug("GRID GET PIVOT: point "//TRIM(tl_var%c_point))
-            ! T-point pivot !case of ORCA2, ORCA025, ORCA12 grid
-            it1=1 ; jt1=4 
-            it2=3 ; jt2=2 
-
-            ! F-point pivot !case of ORCA05 grid
-            if1=1 ; jf1=4 
-            if2=2 ; jf2=3 
-
-            SELECT CASE(TRIM(tl_var%c_point))
-            CASE('T')
-               IF( ABS(tl_var%d_value(it1,jt1,1,1)) == &
-               &   ABS(tl_var%d_value(it2,jt2,1,1)) )THEN
-                  CALL logger_info("GRID GET PIVOT: T-pivot")
-                  grid_get_pivot=1
-               ELSEIF( ABS(tl_var%d_value(if1,jf1,1,1)) == &
-               &       ABS(tl_var%d_value(if2,jf2,1,1)) )THEN
-                  CALL logger_info("GRID GET PIVOT: F-pivot")
-                  grid_get_pivot=0
-               ELSE
-                  CALL logger_error("GRID GET PIVOT: something wrong when "//&
-                  &  "computing pivot point")
-               ENDIF
-            CASE('U')
-               IF( ABS(tl_var%d_value(it1  ,jt1,1,1)) == &
-               &   ABS(tl_var%d_value(it2-1,jt2,1,1)) )THEN
-                  CALL logger_info("GRID GET PIVOT: T-pivot")
-                  grid_get_pivot=1
-               ELSEIF( ABS(tl_var%d_value(if1  ,jf1,1,1)) == &
-               &       ABS(tl_var%d_value(if2-1,jf2,1,1)) )THEN
-                  CALL logger_info("GRID GET PIVOT: F-pivot")
-                  grid_get_pivot=0
-               ELSE
-                  CALL logger_error("GRID GET PIVOT: something wrong when "//&
-                  &  "computing pivot point")
-               ENDIF
-            CASE('V')
-               IF( ABS(tl_var%d_value(it1,jt1  ,1,1)) == &
-               &   ABS(tl_var%d_value(it2,jt2-1,1,1)) )THEN
-                  CALL logger_info("GRID GET PIVOT: T-pivot")
-                  grid_get_pivot=1
-               ELSEIF( ABS(tl_var%d_value(if1,jf1  ,1,1)) == &
-               &       ABS(tl_var%d_value(if2,jf2-1,1,1)) )THEN
-                  CALL logger_info("GRID GET PIVOT: F-pivot")
-                  grid_get_pivot=0
-               ELSE
-                  CALL logger_error("GRID GET PIVOT: something wrong when "//&
-                  &  "computing pivot point")
-               ENDIF
-            CASE('F')
-               IF( ABS(tl_var%d_value(it1  ,jt1  ,1,1)) == &
-               &   ABS(tl_var%d_value(it2-1,jt2-1,1,1)) )THEN
-                  CALL logger_info("GRID GET PIVOT: T-pivot")
-                  grid_get_pivot=1
-               ELSEIF( ABS(tl_var%d_value(if1  ,jf1  ,1,1)) == &
-               &       ABS(tl_var%d_value(if2-1,jf2-1,1,1)) )THEN
-                  CALL logger_info("GRID GET PIVOT: F-pivot")
-                  grid_get_pivot=0
-               ELSE
-                  CALL logger_error("GRID GET PIVOT: something wrong when "//&
-                  &  "computing pivot point")
-               ENDIF
-            END SELECT
-         ELSE
-            CALL logger_error("GRID GET PIVOT: can't compute pivot point. "//&
-            &  "no value associated to variable "//TRIM(tl_var%c_name) )
-         ENDIF
+      IF( il_varid==0 )THEN
+      
+         CALL logger_error("GRID GET PERIO: no suitable variable to compute "//&
+         &              " periodicity in file "//TRIM(td_file%c_name))
 
       ELSE
-         CALL logger_error("GRID GET PIVOT: no suitable variable to compute "//&
-         &              "pivot point in file "//TRIM(td_file%c_name))
-      ENDIF
-
-   END FUNCTION grid_get_pivot
-   !> @endcode
+
+         il_dim(:)= td_file%t_var(il_varid)%t_dim(:)%i_len
+
+         ! read variable
+         tl_var=iom_read_var(td_file, &
+         &                   td_file%t_var(il_varid)%c_name, &
+         &                   id_start=(/1,1,1,1/), &
+         &                   id_count=(/il_dim(1),il_dim(2),1,1/) )
+
+
+         grid__get_perio_file=grid_get_perio(tl_var,il_pivot)
+ 
+         ! clean 
+         CALL var_clean(tl_var)
+
+      ENDIF
+
+   END FUNCTION grid__get_perio_file
    !-------------------------------------------------------------------
    !> @brief 
-   !> This funtion return NEMO periodicity index of the input file.
+   !> This subroutine search NEMO periodicity given mpp structure and optionaly
+   !> pivot point index.
+   !> @details
    !> The variable used must be on T point.
-   !>
-   !> @note the NEMO periodicity index can't be compute from coordinates file,
-   !> neither with mpp files.
    !>
    !> 0: closed boundaries
@@ -243,36 +1542,42 @@
    !> 6: North fold boundary (with a T-point pivot) and cyclic east-west boundary
    !>
+   !> @warning pivot point should have been computed before run this script. see grid_get_pivot.
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @todo 
-   !> - improve check between T or F pivot.
-   !> - manage mpp case (read only border files)
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] id_pivot : pivot point
-   !> @return NEMO periodicity index
-   !-------------------------------------------------------------------
-   !> @code
-   INTEGER(i4) FUNCTION grid_get_perio(td_file, id_pivot)
+   !> - October, 2014 - Initial version
+   !
+   !> @param[in] td_mpp   mpp file structure
+   !> @param[in] id_pivot pivot point index
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_perio_mpp(td_mpp, id_pivot)
       IMPLICIT NONE
 
       ! Argument      
-      TYPE(TFILE), INTENT(IN) :: td_file
-      INTEGER(i4), INTENT(IN) :: id_pivot
+      TYPE(TMPP) , INTENT(IN) :: td_mpp
+      INTEGER(i4), INTENT(IN), OPTIONAL :: id_pivot
+
+      ! function
+      INTEGER(i4) :: grid__get_perio_mpp
 
       ! local variable
+      INTEGER(i4)                       :: il_varid
+      INTEGER(i4)                       :: il_pivot
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_dim
+
       TYPE(TVAR)                        :: tl_var
-      INTEGER(i4)                       :: il_varid
-      INTEGER(i4), DIMENSION(ip_maxdim) :: il_dim
 
       ! loop indices
       INTEGER(i4) :: ji
       !----------------------------------------------------------------
-
       ! initialise
-      grid_get_perio=-1
-
-      IF( id_pivot < 0 .OR. id_pivot > 1 )THEN
+      grid__get_perio_mpp=-1
+
+      IF(PRESENT(id_pivot) )THEN
+         il_pivot=id_pivot
+      ELSE
+         il_pivot=grid_get_pivot(td_mpp)
+      ENDIF
+
+      IF( il_pivot < 0 .OR. il_pivot > 1 )THEN
          CALL logger_error("GRID GET PERIO: invalid pivot point index. "//&
          &  "you should use grid_get_pivot to compute it")
@@ -281,7 +1586,7 @@
       ! look for suitable variable
       il_varid=0
-      DO ji=1,td_file%i_nvar
-         IF( .NOT. ALL(td_file%t_var(ji)%t_dim(1:2)%l_use) ) CYCLE
-         SELECT CASE(TRIM(fct_lower(td_file%t_var(ji)%c_stdname)) )
+      DO ji=1,td_mpp%t_proc(1)%i_nvar
+         IF( .NOT. ALL(td_mpp%t_proc(1)%t_var(ji)%t_dim(1:2)%l_use) ) CYCLE
+         SELECT CASE(TRIM(fct_lower(td_mpp%t_proc(1)%t_var(ji)%c_stdname)) )
             CASE('longitude','latitude')
             CASE DEFAULT
@@ -292,122 +1597,289 @@
 
       IF( il_varid==0 )THEN
-
+      
          CALL logger_error("GRID GET PERIO: no suitable variable to compute "//&
-         &              " periodicity in file "//TRIM(td_file%c_name))
+         &              " periodicity in file "//TRIM(td_mpp%c_name))
       ELSE
-         il_dim(:)=td_file%t_var(il_varid)%t_dim(:)%i_len
-
-         IF( ASSOCIATED(td_file%t_var(il_varid)%d_value) )THEN
-            tl_var=td_file%t_var(il_varid)
-         ELSE
-            ! read variable
-            tl_var=iom_read_var(td_file, td_file%t_var(il_varid)%c_name, &
-            &                   id_start=(/1,1,1,1/), &
-            &                   id_count=(/il_dim(1),il_dim(2),1,1/) )
+ 
+         DO ji=1,ip_maxdim
+            IF( td_mpp%t_proc(1)%t_var(il_varid)%t_dim(ji)%l_use )THEN
+               il_dim(ji)=td_mpp%t_dim(ji)%i_len
+            ELSE
+               il_dim(ji)=1
+            ENDIF
+         ENDDO
+
+         ! read variable
+         tl_var=iom_mpp_read_var(td_mpp, &
+         &                       td_mpp%t_proc(1)%t_var(il_varid)%c_name, &
+         &                       id_start=(/1,1,1,1/), &
+         &                       id_count=(/il_dim(1),il_dim(2),1,1/) )
+
+         grid__get_perio_mpp=grid_get_perio(tl_var, il_pivot)
+
+         ! clean 
+         CALL var_clean(tl_var)
+      ENDIF
+
+   END FUNCTION grid__get_perio_mpp
+   !-------------------------------------------------------------------
+   !> @brief This function get East-West overlap.
+   !
+   !> @details
+   !> If no East-West wrap return -1, 
+   !> else return the size of the ovarlap band.
+   !> East-West overlap is computed comparing longitude value of the  
+   !> South" part of the domain, to avoid  north fold boundary.
+   !>
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !>
+   !> @param[in] td_lon longitude variable structure 
+   !> @return East West overlap
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_ew_overlap_var(td_var)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TVAR), INTENT(INOUT) :: td_var
+      ! function
+      INTEGER(i4) :: grid__get_ew_overlap_var
+
+      ! local variable
+      REAL(dp), DIMENSION(:,:), ALLOCATABLE :: dl_value
+      REAL(dp), DIMENSION(:)  , ALLOCATABLE :: dl_vare
+      REAL(dp), DIMENSION(:)  , ALLOCATABLE :: dl_varw
+
+      REAL(dp)    :: dl_delta
+      REAL(dp)    :: dl_varmax
+      REAL(dp)    :: dl_varmin
+
+      INTEGER(i4) :: il_east
+      INTEGER(i4) :: il_west
+      INTEGER(i4) :: il_jmin
+      INTEGER(i4) :: il_jmax
+
+      INTEGER(i4), PARAMETER :: il_max_overlap = 5
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      ! initialise
+      grid__get_ew_overlap_var=-1
+
+      IF( ASSOCIATED(td_var%d_value) )THEN
+         IF( td_var%t_dim(1)%i_len > 1 )THEN
+            il_west=1
+            il_east=td_var%t_dim(1)%i_len
+
+            ALLOCATE( dl_value(td_var%t_dim(1)%i_len, &
+            &                  td_var%t_dim(2)%i_len) )
+
+            dl_value(:,:)=td_var%d_value(:,:,1,1)
+
+            ! we do not use jmax as dimension length due to north fold boundary
+            il_jmin=1+ip_ghost
+            il_jmax=(td_var%t_dim(2)%i_len-ip_ghost)/2
+
+            ALLOCATE( dl_vare(il_jmax-il_jmin+1) )
+            ALLOCATE( dl_varw(il_jmax-il_jmin+1) )
+            
+            dl_vare(:)=dl_value(il_east,il_jmin:il_jmax)
+            dl_varw(:)=dl_value(il_west,il_jmin:il_jmax)
+            
+            IF( .NOT.(  ALL(dl_vare(:)==td_var%d_fill) .AND. &
+            &           ALL(dl_varw(:)==td_var%d_fill) ) )THEN
+         
+               IF( TRIM(td_var%c_stdname) == 'longitude' )THEN
+                  WHERE( dl_value(:,:) > 180._dp .AND. &
+                  &      dl_value(:,:) /= td_var%d_fill ) 
+                     dl_value(:,:)=360.-dl_value(:,:)
+                  END WHERE
+
+                  dl_varmax=MAXVAL(dl_value(:,il_jmin:il_jmax))
+                  dl_varmin=MINVAL(dl_value(:,il_jmin:il_jmax))
+
+                  dl_delta=(dl_varmax-dl_varmin)/td_var%t_dim(1)%i_len
+
+                  IF( ALL(ABS(dl_vare(:)) - ABS(dl_varw(:)) == dl_delta) )THEN
+                     grid__get_ew_overlap_var=0
+                  ENDIF
+               ENDIF
+
+               IF( grid__get_ew_overlap_var == -1 )THEN
+                  DO ji=0,il_max_overlap
+
+                     IF( il_east-ji == il_west )THEN
+                        ! case of small domain
+                        EXIT
+                     ELSE
+                        dl_vare(:)=dl_value(il_east-ji,il_jmin:il_jmax)
+                        
+                        IF( ALL( dl_varw(:) == dl_vare(:) ) )THEN
+                           grid__get_ew_overlap_var=ji+1
+                           EXIT
+                        ENDIF
+                     ENDIF
+
+                  ENDDO
+               ENDIF
+            ENDIF
+
          ENDIF
-
-         IF(ALL(tl_var%d_value(    1    ,    :    ,1,1)/=tl_var%d_fill).AND.&
-         &  ALL(tl_var%d_value(il_dim(1),    :    ,1,1)/=tl_var%d_fill).AND.&
-         &  ALL(tl_var%d_value(    :    ,    1    ,1,1)/=tl_var%d_fill).AND.&
-         &  ALL(tl_var%d_value(    :    ,il_dim(2),1,1)/=tl_var%d_fill))THEN
-         ! no boundary closed
-            CALL logger_warn("GRID GET PERIO: can't determined periodicity. "//&
-            &             "there is no boundary closed for variable "//&
-            &              TRIM(tl_var%c_name)//" in file "//&
-            &              TRIM(td_file%c_name) )
-         ELSE
-            ! check periodicity
-            IF(ANY(tl_var%d_value(   1     ,:,1,1)/=tl_var%d_fill).OR.&
-            &  ANY(tl_var%d_value(il_dim(1),:,1,1)/=tl_var%d_fill))THEN
-            ! East-West cyclic (1,4,6)
-
-               IF( ANY(tl_var%d_value(:, 1, 1, 1) /= tl_var%d_fill) )THEN
-               ! South boundary not closed 
-
-                  CALL logger_error("GRID GET PERIO: should have been an "//&
-                  &              "impossible case")
-                  CALL logger_debug("GRID GET PERIO: East_West cyclic")
-                  CALL logger_debug("GRID GET PERIO: South boundary not closed")
-
-               ELSE
-               ! South boundary closed (1,4,6)
-                  CALL logger_info("GRID GET PERIO: South boundary closed")
-
-                  IF(ANY(tl_var%d_value(:,il_dim(2),1,1)/=tl_var%d_fill) )THEN
-                  ! North boundary not closed (4,6)
-                     CALL logger_info("GRID GET PERIO: North boundary not closed")
-                     ! check pivot
-                     SELECT CASE(id_pivot)
-                        CASE(0)
-                           ! F pivot
-                           grid_get_perio=4
-                        CASE(1)
-                           ! T pivot
-                           grid_get_perio=6
-                        CASE DEFAULT
-                           CALL logger_error("GRID GET PERIO: invalid pivot ")
-                     END SELECT
-                  ELSE
-                  ! North boundary closed
-                     CALL logger_info("GRID GET PERIO: North boundary closed")
-                     grid_get_perio=1 ! North and South boundaries closed
-                  ENDIF
-
-               ENDIF
-
-            ELSE
-            ! East-West boundaries closed (0,2,3,5)
-               CALL logger_info("GRID GET PERIO: East West boundaries closed")
-
-               IF( ANY(tl_var%d_value(:, 1, 1, 1) /= tl_var%d_fill) )THEN
-               ! South boundary not closed (2)
-                  CALL logger_info("GRID GET PERIO: South boundary not closed")
-
-                  IF(ANY(tl_var%d_value(:,il_dim(2),1,1)/=tl_var%d_fill))THEN
-                  ! North boundary not closed
-                     CALL logger_error("GRID GET PERIO: should have been "//&
-                     &              "an impossible case")
-                     CALL logger_debug("GRID GET PERIO: East West boundaries "//&
-                     &              "closed")
-                     CALL logger_debug("GRID GET PERIO: South boundary not closed")
-                     CALL logger_debug("GRID GET PERIO: North boundary not closed")
-                  ELSE
-                  ! North boundary closed
-                     grid_get_perio=2   ! East-West and North boundaries closed 
-                  ENDIF
-
-               ELSE
-               ! South boundary closed (0,3,5)
-                  CALL logger_info("GRID GET PERIO: South boundary closed")
-
-                  IF(ANY(tl_var%d_value(:,il_dim(2),1,1)/=tl_var%d_fill))THEN
-                  ! North boundary not closed (3,5)
-                     CALL logger_info("GRID GET PERIO: North boundary not closed")
-                     ! check pivot
-                     SELECT CASE(id_pivot)
-                        CASE(0)
-                           ! F pivot
-                           grid_get_perio=3
-                        CASE(1)
-                           ! T pivot
-                           grid_get_perio=5
-                        CASE DEFAULT
-                           CALL logger_error("GRID GET PERIO: invalid pivot")
-                     END SELECT
-                  ELSE
-                  ! North boundary closed   
-                     CALL logger_info("GRID GET PERIO: North boundary closed")
-                     grid_get_perio=0   ! all boundary closed
-                  ENDIF
-
-               ENDIF
-
-            ENDIF
-
+      ELSE
+         CALL logger_error("GRID GET EW OVERLAP: input variable standard name"//&
+         &  TRIM(td_var%c_stdname)//" can not be used to compute East West "//&
+         &  "overalp. no value associated. ")
+      ENDIF
+
+   END FUNCTION grid__get_ew_overlap_var
+   !-------------------------------------------------------------------
+   !> @brief This function get East-West overlap.
+   !
+   !> @details
+   !> If no East-West wrap return -1, 
+   !> else return the size of the ovarlap band.
+   !> East-West overlap is computed comparing longitude value of the  
+   !> South" part of the domain, to avoid  north fold boundary.
+   !>
+   !> @author J.Paul
+   !> - October, 2014- Initial Version
+   !>
+   !> @param[in] td_file file structure 
+   !> @return East West overlap
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_ew_overlap_file(td_file)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TFILE), INTENT(INOUT) :: td_file
+      ! function
+      INTEGER(i4) :: grid__get_ew_overlap_file
+
+      ! local variable
+      INTEGER(i4) :: il_varid
+
+      TYPE(TVAR)  :: tl_var
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      il_varid=var_get_index(td_file%t_var(:), 'longitude')
+      IF( il_varid /= 0 )THEN
+         ! read longitude on boundary
+         tl_var=iom_read_var(td_file, 'longitude')
+      ELSE
+         DO ji=1,td_file%i_nvar
+            IF( .NOT. ALL(td_file%t_var(ji)%t_dim(1:2)%l_use) ) CYCLE
+
+            tl_var=iom_read_var(td_file, td_file%t_var(ji)%c_name)
+            EXIT
+         ENDDO
+      ENDIF
+
+      grid__get_ew_overlap_file=grid_get_ew_overlap(tl_var)
+
+      ! clean
+      CALL var_clean(tl_var)
+
+   END FUNCTION grid__get_ew_overlap_file
+   !-------------------------------------------------------------------
+   !> @brief This function get East-West overlap.
+   !
+   !> @details
+   !> If no East-West wrap return -1, 
+   !> else return the size of the ovarlap band.
+   !> East-West overlap is computed comparing longitude value of the  
+   !> South" part of the domain, to avoid  north fold boundary.
+   !>
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !>
+   !> @param[in] td_mpp mpp structure 
+   !> @return East West overlap
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_ew_overlap_mpp(td_mpp)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TMPP), INTENT(INOUT) :: td_mpp
+      ! function
+      INTEGER(i4) :: grid__get_ew_overlap_mpp
+
+      ! local variable
+      INTEGER(i4) :: il_ew
+      INTEGER(i4) :: il_varid
+
+      TYPE(TVAR)  :: tl_var
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      ! initialise
+      grid__get_ew_overlap_mpp=td_mpp%i_ew
+
+      ! read longitude on boundary
+      il_varid=var_get_index(td_mpp%t_proc(1)%t_var(:),'longitude')
+      IF( il_varid /= 0 )THEN
+         tl_var=iom_mpp_read_var(td_mpp, 'longitude')
+      ELSE
+         DO ji=1,td_mpp%t_proc(1)%i_nvar
+            IF( .NOT. ALL(td_mpp%t_proc(1)%t_var(ji)%t_dim(1:2)%l_use) ) CYCLE
+
+            tl_var=iom_mpp_read_var(td_mpp, td_mpp%t_proc(1)%t_var(ji)%c_name)
+            EXIT
+         ENDDO         
+      ENDIF
+
+      il_ew=grid_get_ew_overlap(tl_var)
+      IF( il_ew >= 0 )THEN
+         grid__get_ew_overlap_mpp=il_ew
+      ENDIF
+
+
+      ! clean
+      CALL var_clean(tl_var)
+
+   END FUNCTION grid__get_ew_overlap_mpp
+   !-------------------------------------------------------------------
+   !> @brief This subroutine check if there is north fold.
+   !>
+   !> @details
+   !> check if maximum latitude greater than 88°N 
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[in] td_lat latitude variable structure 
+   !-------------------------------------------------------------------
+   LOGICAL FUNCTION grid_is_north_fold(td_lat)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TVAR), INTENT(IN) :: td_lat
+
+      ! local variable
+      ! loop indices
+      !----------------------------------------------------------------
+   
+      ! init
+      grid_is_north_fold=.FALSE.
+
+      IF( .NOT. ASSOCIATED(td_lat%d_value) )THEN
+         CALL logger_error("GRID IS NORTH FOLD: "//&
+         &                 " no value associated to latitude")
+      ELSE      
+         IF( MAXVAL(td_lat%d_value(:,:,:,:), &
+         &          td_lat%d_value(:,:,:,:)/= td_lat%d_fill) >= 88.0 )THEN
+
+            grid_is_north_fold=.TRUE.
+            
          ENDIF
       ENDIF
 
-   END FUNCTION grid_get_perio
-   !> @endcode
+   END FUNCTION grid_is_north_fold
    !-------------------------------------------------------------------
    !> @brief This subroutine check domain validity.
@@ -415,23 +1887,21 @@
    !> @details
    !> If maximum latitude greater than 88°N, program will stop. 
-   !> It is not able to manage north fold boundary for now.
+   !> @note Not able to manage north fold for now.
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_coord : coordinate file 
-   !> @param[in] id_imin : i-direction lower left  point indice  
-   !> @param[in] id_imax : i-direction upper right point indice 
-   !> @param[in] id_jmin : j-direction lower left  point indice 
-   !> @param[in] id_jmax : j-direction upper right point indice 
-   !>
-   !> @todo
-   !> - use domain instead of start count
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !
+   !> @param[in] cd_coord  coordinate file 
+   !> @param[in] id_imin   i-direction lower left  point indice  
+   !> @param[in] id_imax   i-direction upper right point indice 
+   !> @param[in] id_jmin   j-direction lower left  point indice 
+   !> @param[in] id_jmax   j-direction upper right point indice 
+   !-------------------------------------------------------------------
    SUBROUTINE grid_check_dom(td_coord, id_imin, id_imax, id_jmin, id_jmax)
       IMPLICIT NONE
       ! Argument      
-      TYPE(TFILE), INTENT(IN) :: td_coord
+      TYPE(TMPP) , INTENT(IN) :: td_coord
       INTEGER(i4), INTENT(IN) :: id_imin
       INTEGER(i4), INTENT(IN) :: id_imax
@@ -440,16 +1910,13 @@
 
       ! local variable
-      TYPE(TVAR)                        :: tl_var
-
-      TYPE(TFILE)                       :: tl_coord
-
-      TYPE(TMPP)                        :: tl_mppcoord
-
-      TYPE(TDOM)                        :: tl_dom
-
+      TYPE(TVAR) :: tl_var
+
+      TYPE(TMPP) :: tl_coord
+
+      TYPE(TDOM) :: tl_dom
       ! loop indices
       !----------------------------------------------------------------
 
-      IF( id_jmin >= id_jmax )THEN
+      IF( id_jmin > id_jmax .OR. id_jmax == 0 )THEN
 
          CALL logger_fatal("GRID CHECK DOM: invalid domain. "//&
@@ -457,9 +1924,4 @@
 
       ELSE
-
-         IF( td_coord%i_id == 0 )THEN
-            CALL logger_error("GRID CHECK DOM: can not check domain. "//&
-            &  " file "//TRIM(td_coord%c_name)//" not opened." )
-         ELSE
 
             IF( id_imin == id_imax .AND. td_coord%i_ew < 0 )THEN
@@ -469,36 +1931,23 @@
             ENDIF
 
-            !1- read domain
-            tl_coord=td_coord
-            CALL iom_open(tl_coord)
-
-            !1-1 compute domain
+            ! copy structure
+            tl_coord=mpp_copy(td_coord)
+
+            ! compute domain
             tl_dom=dom_init( tl_coord,        &
-            &                 id_imin, id_imax,&
-            &                 id_jmin, id_jmax )
+            &                id_imin, id_imax,&
+            &                id_jmin, id_jmax )
             
-            !1-2 close file
-            CALL iom_close(tl_coord)
-
-            !1-3 read variables on domain (ugly way to do it, have to work on it)
-            !1-3-1 init mpp structure
-            tl_mppcoord=mpp_init(tl_coord)   
-
-            CALL file_clean(tl_coord)
-
-            !1-3-2 get processor to be used
-            CALL mpp_get_use( tl_mppcoord, tl_dom )
-
-            !1-3-3 open mpp files
-            CALL iom_mpp_open(tl_mppcoord)
-
-            !1-3-4 read variable value on domain
-            tl_var=iom_mpp_read_var(tl_mppcoord,'latitude',td_dom=tl_dom)
-
-            !1-3-5 close mpp files
-            CALL iom_mpp_close(tl_mppcoord)
-
-            !1-3-6 clean structure
-            CALL mpp_clean(tl_mppcoord)
+            ! open mpp files to be used
+            CALL iom_dom_open(tl_coord, tl_dom)
+
+            ! read variable value on domain
+            tl_var=iom_dom_read_var(tl_coord,'latitude',tl_dom)
+
+            ! close mpp files
+            CALL iom_dom_close(tl_coord)
+
+            ! clean structure
+            CALL mpp_clean(tl_coord)
 
             IF( MAXVAL(tl_var%d_value(:,:,:,:), &
@@ -513,41 +1962,49 @@
 
             ! clean
+            CALL dom_clean(tl_dom)
             CALL var_clean(tl_var)
 
-         ENDIF
-
-
       ENDIF
 
    END SUBROUTINE grid_check_dom
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function get closest coarse grid indices of fine grid domain.
    !
    !> @details
-   !>
-   !
+   !> it use coarse and fine grid coordinates files.
+   !> optionally, you could specify the array of refinment factor (default 1.)
+   !> optionally, you could specify on which Arakawa grid point you want to
+   !> work (default 'T')
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_coord0 : coarse grid coordinate structure
-   !> @param[in] td_coord1 : fine grid coordinate structure
-   !> @return coarse grid indices (/ (/imin0, imax0/), (/jmin0, jmax0/) /)
-   !> @todo
-   !> - use domain instead of start count
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION grid_get_coarse_index_ff( td_coord0, td_coord1, &
-   &                                  id_rho )
+   !> - November, 2013- Initial Version
+   !> @date September, 2014
+   !> - use grid point to read coordinates variable. 
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !>
+   !> @param[in] td_coord0 coarse grid coordinate mpp structure
+   !> @param[in] td_coord1 fine grid coordinate mpp structure
+   !> @param[in] id_rho    array of refinment factor (default 1.)
+   !> @param[in] cd_point  Arakawa grid point (default 'T').
+   !> @return coarse grid indices(/(/imin0, imax0/), (/jmin0, jmax0/)/)
+   !>                                     
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_coarse_index_ff( td_coord0, td_coord1, &
+   &                                   id_rho, cd_point )
       IMPLICIT NONE
       ! Argument
-      TYPE(TFILE), INTENT(IN) :: td_coord0
-      TYPE(TFILE), INTENT(IN) :: td_coord1
-      INTEGER(i4), DIMENSION(:), INTENT(IN), OPTIONAL :: id_rho
+      TYPE(TMPP)                    , INTENT(IN) :: td_coord0
+      TYPE(TMPP)                    , INTENT(IN) :: td_coord1
+      INTEGER(i4)     , DIMENSION(:), INTENT(IN), OPTIONAL :: id_rho
+      CHARACTER(LEN=*)              , INTENT(IN), OPTIONAL :: cd_point
 
       ! function
-      INTEGER(i4), DIMENSION(2,2,2) :: grid_get_coarse_index_ff
+      INTEGER(i4), DIMENSION(2,2) :: grid__get_coarse_index_ff
 
       ! local variable
+      TYPE(TMPP) :: tl_coord0
+      TYPE(TMPP) :: tl_coord1
+
       TYPE(TVAR)  :: tl_lon0
       TYPE(TVAR)  :: tl_lat0
@@ -555,10 +2012,8 @@
       TYPE(TVAR)  :: tl_lat1
 
-      INTEGER(i4) , DIMENSION(:), ALLOCATABLE :: il_rho
-
-      INTEGER(i4), DIMENSION(ip_maxdim) :: il_start
-      INTEGER(i4), DIMENSION(ip_maxdim) :: il_count
-      INTEGER(i4), DIMENSION(2)         :: il_xghost0
-      INTEGER(i4), DIMENSION(2)         :: il_xghost1
+      INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
+
+      INTEGER(i4), DIMENSION(2,2)         :: il_xghost0
+      INTEGER(i4), DIMENSION(2,2)         :: il_xghost1
 
       INTEGER(i4) :: il_imin0
@@ -567,8 +2022,6 @@
       INTEGER(i4) :: il_jmax0
 
-      INTEGER(i4) :: il_imin1
-      INTEGER(i4) :: il_imax1
-      INTEGER(i4) :: il_jmin1
-      INTEGER(i4) :: il_jmax1
+      CHARACTER(LEN= 1) :: cl_point
+      CHARACTER(LEN=lc) :: cl_name
 
       ! loop indices
